﻿using System;

namespace Rp1210Example
{
    public interface IRp1210Api
    {
        short ClientConnect(int client, short deviceId, string protocol, int txBufferSize, int rxBufferSize, short isAppPacketizingIncomingMsgs);
        short ClientDisconnect(short clientId);
        short SendMessage(short clientId, byte[] clientMessage, short messageSize, short notifyStatusOnTx, short blockOnSend);
        short ReadMessage(short clientId, byte[] apiMessage, short bufferSize, short blockOnRead);
        short SendCommand(short commandNumber, short clientId, byte[] clientCommand, short messageSize);
        void ReadVersion(byte[] dllMajor, byte[] dllMinor, byte[] apiMajor, byte[] apiMinor);
        short GetErrorMsg(short errorCode, byte[] description);
        short GetHardwareStatus(short clientId, byte[] clientInfo, short infoSize, short blockOnRequest);
        short ReadDetailedVersion(short clientId, byte[] apiVersion, byte[] dllVersion, byte[] fwVersion);
        short Ioctl(short clientId, int ioctlId, IntPtr input, IntPtr output);
        //bool SetBluetoothAddress(string macAddress);

        /// <summary>
        /// Sets the RP1210 API implementation.
        /// </summary>
        /// <param name="implementation">The RP1210 API implementation, i.e., "NULN2R32" or "CIL7R32"</param>
        void SetImplementation(string implementation);
    }
}
